//2017年10月1日晚  kingdomhua笔记
//需要加载OLED库和RC522库，并使用各自的头文件
#include "U8glib.h"
#include <SPI.h>
#include <MFRC522.h>
//使用OLED的i2c必须用一下语句：
U8GLIB_SSD1306_128X64 u8g(U8G_I2C_OPT_NONE);  // I2C / TWI 
//8,9,10,11 change is 3,4,5,6
//引脚定义
#define in1 3
#define in2 4
#define in3 5
#define in4 6
#define RST_PIN 9
#define SS_PIN  10
//卡片UID存储
byte UID1[4] = {0,0,0,0};
byte UID2[4] = {0xEB,0x38,0x14,0x55};//my card
MFRC522 mfrc522(SS_PIN,RST_PIN);
//OLED显示
char str1[]="IDT Wireless";
char str2[]="Power Supply:";
char str3[]="Wired";
char str4[]="IDT smart car";
char str5[]="Battery Supply";
char str6[]="Bluetooth ctl:";
char str7[]="Car forward";
char str8[]="Car backward";
char str9[]="Turn left";
char str10[]="Turn right";
char strv[]="VRMS:";
char stri[]="IRMS:";

char i;

 float temp;
 float SUM=0.0;
 float VRMS;
 char rc522_flag=0;
 //使用函数
void rc522_init();
void dump_byte_array(byte *buffer, byte bufferSize);
void Motor();
void draw(void);
void draw_meuo();
void OneCheck(float Vcc,float step,float mult,float Rcc);

//系统初始化
void setup() {
  // put your setup code here, to run once:
  i=0;
  pinMode(in1,OUTPUT);
  pinMode(in2,OUTPUT);
  pinMode(in3,OUTPUT);
  pinMode(in4,OUTPUT);
  Serial.begin(115200);
  SPI.begin();
  mfrc522.PCD_Init();
}
//主程序循环
void loop() {

  rc522_init();
  if(rc522_flag==0){
    clear_s();
     if(UID2[0]==UID1[0]&&UID2[1]==UID1[1]&&UID2[2]==UID1[2]&&UID2[3]==UID1[3]){
      rc522_flag=1;
     }
  }
  if(rc522_flag==1){
     Motor();
  if(VRMS>4){
      u8g.firstPage();  
      do {
        draw();
       } while( u8g.nextPage() );
  }
  else{
     u8g.firstPage();  
       do {
          draw_meuo();
       } while( u8g.nextPage() );
  }
    SUM=0.0;
    for(char i=10;i>0;i--){
      OneCheck(5.0,1023,2000,1);
      SUM=SUM+temp;
    }
    SUM=SUM/10;
    delay(500); 
  }

}
void rc522_init(){
  // put your main code here, to run repeatedly:
  if ( ! mfrc522.PICC_IsNewCardPresent()) {
    return;
  }
  if ( ! mfrc522.PICC_ReadCardSerial()) {
    return;
  }
//  Serial.print("UID:");
  dump_byte_array(mfrc522.uid.uidByte,mfrc522.uid.size);
//  delay(1000);
//  Serial.print(UID1[0],HEX);
//  Serial.print(UID1[1],HEX);
//  Serial.print(UID1[2],HEX);
//  Serial.print(UID1[3],HEX);
  mfrc522.PICC_HaltA();
}
void dump_byte_array(byte *buffer, byte bufferSize) 
{
  for (byte i = 0; i < bufferSize; i++) 
  {
//   Serial.print(buffer[i],HEX);//十六进制打印
    UID1[i]=buffer[i];
//    Serial.print(" ");
  }
}
void Motor(){
  if(Serial.available()){
    i=Serial.read();
    if(i=='2'){
    
      digitalWrite(in1, LOW);//back
      digitalWrite(in2, HIGH);
      digitalWrite(in3, LOW);//back
      digitalWrite(in4, HIGH);
    }
    if(i=='8'){   
      
      digitalWrite(in1, HIGH);//go
      digitalWrite(in2, LOW);
      digitalWrite(in3, HIGH);//go
      digitalWrite(in4, LOW);
    }
    if(i=='4'){     
      
      digitalWrite(in1, LOW);//stop
      digitalWrite(in2, LOW);
      digitalWrite(in3, HIGH);//go
      digitalWrite(in4, LOW);
    }
    if(i=='6'){
      
      
      digitalWrite(in1, HIGH);//go
      digitalWrite(in2, LOW);
      digitalWrite(in3, LOW);//stop
      digitalWrite(in4, LOW);
    }
    if(i=='5'){
      digitalWrite(in1, LOW);//go
      digitalWrite(in2, LOW);
      digitalWrite(in3, LOW);//stop
      digitalWrite(in4, LOW);
    }
  }
}

void draw(void) {
  u8g.setFont(u8g_font_unifont);
  u8g.setPrintPos(10, 10);
  u8g.print(str2);
  u8g.setPrintPos(10, 25);
  u8g.print(str1);
  u8g.setPrintPos(10, 45);
  u8g.print(strv);
  u8g.print(VRMS);
  u8g.print("V");
  u8g.setPrintPos(10, 60);
  u8g.print(stri);
  u8g.print(SUM);
  u8g.print("mA");
}
void draw_meuo(){
  u8g.setFont(u8g_font_unifont);
  u8g.setPrintPos(10, 10);
  u8g.print(str4);
  u8g.setPrintPos(10, 45);
  u8g.print(str5);  
}
void clear_s(){
  u8g.firstPage();  
      do {
        u8g.setPrintPos(0,0);
        u8g.setFont(u8g_font_unifont);
       // u8g.print('.');
       } while( u8g.nextPage() );
}
//因为有检测回流 所以增加两个判断语句。
void OneCheck(float Vcc,float step,float mult,float Rcc){
  int V1 = analogRead(A0); 
  int V2 = analogRead(A1);
  VRMS=V1*Vcc/step*2;
  if(VRMS>=5.5){
    VRMS=V2*2.0/step;
  }
  float V_temp1 = V1*(Vcc / step)*mult;
  float V_temp2 = V2*(Vcc / step)*mult;
  temp=V_temp1-V_temp2;
  if(temp<0){
  	temp=-temp;
  }
  temp=temp/Rcc;
}
